const createToast = function (uniqueClass, header, body) {
  const toast = document.createElement("div");
  toast.classList.add("toast");
  toast.classList.add(uniqueClass);

  toast.setAttribute("role", "alert");
  toast.setAttribute("aria-live", "assertive");
  toast.setAttribute("aria-atomic", "true");

  const toastHeader = document.createElement("div");
  toastHeader.classList.add("toast-header");

  const strong = document.createElement("strong");
  strong.classList.add("mr-auto");
  strong.textContent = header;

  const closeButton = document.createElement("button");
  closeButton.setAttribute("type", "button");
  closeButton.classList.add("ml-2", "mb-1", "close");
  closeButton.setAttribute("data-dismiss", "toast");
  closeButton.setAttribute("aria-label", "Close");

  const closeIcon = document.createElement("span");
  closeIcon.setAttribute("aria-hidden", "true");
  closeIcon.innerHTML = "&times;";

  const toastBody = document.createElement("div");
  toastBody.classList.add("toast-body");
  toastBody.textContent = body;

  // Append child elements to the toast
  closeButton.appendChild(closeIcon);
  toastHeader.appendChild(strong);
  toastHeader.appendChild(closeButton);
  toast.appendChild(toastHeader);
  toast.appendChild(toastBody);

  // Add the toast to the DOM
  const container = document.querySelector(".toastContainer");
  container.appendChild(toast);

  // Show the toast
  $(toast).toast("show");
};
