// usefull event handling functions
// to fetch data

const setData = function (data) {
  console.log(data);
  console.log(data.Tenth_Marksheet);
  tenthMarksheet.src = data?.Tenth_Marksheet;
  twelvethMarksheet.src = data?.Twelveth_Marksheet;
  diploma.src = data?.Diploma_Marksheet;
  bachelor.src = data?.Bachelor_Marksheet;
  master.src = data?.Master_Marksheet;
  lor.src = data?.Lor;
  sop.src = data?.Sop;
  resume.src = data?.Resume;
  laexam.src = data?.Language_Exam;
};
const getAppData = async function (appId) {
  const localData = getFromLocalStorage("loginInfo", true);
  const response = await ajaxCall(
    `/applications/${appId}/`,
    {
      headers: {
        Accept: "application/json",
        "Content-Type": "application/json",
        Authorization: `Bearer ${localData.accessToken}`,
      },
      method: "GET",
    },
    8000
  );
  console.log(response.data);
  appName.innerHTML = response.data?.name?.student_name;
  assignedUser.innerHTML = response.data?.assigned_users?.username;
  appStatus.innerHTML = response.data?.status?.App_status;

  tenthMarksheet.src = response.data?.Tenth_Marksheet;
  twelvethMarksheet.src = response.data?.Twelveth_Marksheet;
  diploma.src = response.data?.Diploma_Marksheet;
  bachelor.src = response.data?.Bachelor_Marksheet;
  master.src = response.data?.Master_Marksheet;
  lor.src = response.data?.Lor;
  sop.src = response.data?.Sop;
  resume.src = response.data?.Resume;
  laexam.src = response.data?.Language_Exam;
  await selectVal(
    "/view-enquiry/",
    ["student_name"],
    appNameSelect,
    "Select Applicant",
    "No Applicant Found"
  );
  $(appNameSelect).val(response.data?.name?.id);

  await selectVal(
    "/userlist/",
    ["username"],
    assUserSelect,
    "Select User",
    "No users Found"
  );
  $(assUserSelect).val(response.data?.assigned_users?.id);
  await selectVal(
    "/appstatus/",
    ["App_status"],
    statusSelect,
    "Select App status",
    "No App status Found"
  );
  $(statusSelect).val(response.data?.status?.id);
  $(".selectpicker").selectpicker("refresh");
  return response.data;
};

const changeSelectionVal = async function (
  prop,
  appId,
  isFile,
  toggleEle,
  toggleEle2,
  classn = "abc",
  title = "",
  pendingMsg = "",
  successMsg = "",
  progressBar = "",
  e
) {
  const localData = getFromLocalStorage("loginInfo", true);

  const fdata = new FormData();
  let val, obj;
  if (isFile) {
    console.log(isFile);
    progressBar.classList.remove("hide");
    val = e.target.files[0];
    fdata.append(prop, val);
    obj = {
      method: "PATCH",
      headers: {
        Authorization: `Bearer ${localData.accessToken}`,
      },
      body: fdata,
      onUploadProgress: (progressEvent) => {
        const { loaded, total } = progressEvent;
        console.log(total, loaded);
        const percentComplete = (loaded / total) * 100;
        progressBar.value = percentComplete;
      },
    };
  } else {
    val = +e.target.value;
    fdata.append(prop, val);
    obj = {
      method: "PATCH",
      headers: {
        Authorization: `Bearer ${localData.accessToken}`,
      },

      body: fdata,
    };
  }
  createToast(classn, title, pendingMsg);
  if (isFile) {
    let request = new XMLHttpRequest();
    request.open(
      "PATCH",
      `https://flyurdream.online/api/update-application/${appId}/`
    );
    request.setRequestHeader(
      "Authorization",
      `Bearer ${localData.accessToken}`
    );
    request.upload.addEventListener("progress", function (e) {
      // upload progress as percentage
      let percent_completed = (e.loaded / e.total) * 100;
      progressBar.value = percent_completed;
      console.log("it is", percent_completed);
    });

    request.addEventListener("load", function (e) {
      progressBar.value = 0;
      progressBar.classList.add("hide");
      // HTTP status message (200, 404 etc)
      console.log(request.status);
      setData(JSON.parse(request.response));
      // request.response holds response from the server
      console.log(request.response);
    });
    request.send(fdata);
  } else {
    const response = await ajaxCall(`/update-application/${appId}/`, obj, 8000);
    console.log(response);
  }
  if (!isFile) await getAppData(appId);
  // console.log(data);
  document.querySelector(`.${classn} .toast-body`).textContent = successMsg;
  toggleHide(toggleEle, toggleEle2);
};

const addEvents = function (valDiv, selectDiv, selectEle, btn) {
  valDiv.addEventListener("dblclick", function () {
    toggleHide(valDiv, selectDiv);
    selectDiv.setAttribute("tabindex", "0");
    selectDiv.focus();
    console.log("focus");
  });
  btn.addEventListener("click", function () {
    toggleHide(valDiv, selectDiv);
  });
};

const toggleHide = (item1, item2) => {
  item1.classList.toggle("hide");
  item2.classList.toggle("hide");
};

// get id from url
const urlParams = new URLSearchParams(window.location.search);
const appId = urlParams.get("id");

// lets get all the fields

// export btn
const exportBtn = getEle(".exportBtn");
exportBtn.href = `https://flyurdream.online/pdf/${appId}`;
// main val div
const appName = getEle(".name");
const assignedUser = getEle(".assUsr");
const appStatus = getEle(".appStatus");

// select and edit div
const appNameEdit = getEle(".nameS");
const appNameSelect = getEle("#applicant");

const assUserEdit = getEle(".assUserS");
const assUserSelect = getEle("#assignedUser");

const appStatusEdit = getEle(".appStatusS");
const statusSelect = getEle("#status");

// cancel btns
const cancelNameBtn = getEle(".cancelNameBtn");
const cancelAuBtn = getEle(".cancelAuBtn");
const cancelSBtn = getEle(".cancelSBtn");

// selection of img
const tenthMarksheet = getEle(".tenth_marksheet");
const twelvethMarksheet = getEle(".twelvth_marksheet");
const diploma = getEle(".diploma");
const bachelor = getEle(".bachelor");
const master = getEle(".master");
const lor = getEle(".lor");
const sop = getEle(".sop");
const resume = getEle(".resume");
const laexam = getEle(".laexam");

// selection for document upload container
const tenthContainer = getEle(".tenth_marksheetContainer");
const twelvethContainer = getEle(".twelvth_marksheetContainer");
const diplomaContainer = getEle(".diplomaContainer");
const bachelorContainer = getEle(".bachelorContainer");
const masterContainer = getEle(".masterContainer");
const lorContainer = getEle(".lorContainer");
const sopContainer = getEle(".sopContainer");
const resumeContainer = getEle(".resumeContainer");
const laexamContainer = getEle(".laexamContainer");
// selection for document upload input
const tenthInput = getEle(".tenth_marksheetUpload");
const twelvethInput = getEle(".twelvth_marksheetUpload");
const diplomaInput = getEle(".diplomaUpload");
const bachelorInput = getEle(".bachelorUpload");
const masterInput = getEle(".masterUpload");
const lorInput = getEle(".lorUpload");
const sopInput = getEle(".sopUpload");
const resumeInput = getEle(".resumeUpload");
const laexamInput = getEle(".laexamUpload");

// select progressbars
const progressbartenth = getEle("#progressbartenth");
const progressbartwelth = getEle("#progressbartwelth");
const progressbardiploma = getEle("#progressbardiploma");
const progressbarbachlor = getEle("#progressbarbachlor");
const progressbarmaster = getEle("#progressbarmaster");
const progressbarlor = getEle("#progressbarlor");
const progressbarsop = getEle("#progressbarsop");
const progressbarresume = getEle("#progressbarresume");
const progressbarla = getEle("#progressbarla");

// for name
// addEvents(appName, appNameEdit, appNameSelect, cancelNameBtn);
// for assigned usr
addEvents(assignedUser, assUserEdit, assUserSelect, cancelAuBtn);
// for status
addEvents(appStatus, appStatusEdit, statusSelect, cancelSBtn);

// lets first get data
const appData = getAppData(appId);

// now for select option onchange

// appNameSelect.addEventListener(
//   "change",
//   changeSelectionVal.bind(null, "name", appId, false,)
// );
$("#assignedUser").on(
  "select2:select",
  changeSelectionVal.bind(
    null,
    "assigned_users",
    appId,
    false,
    assignedUser,
    assUserEdit,
    "assignUT",
    "Assigned User",
    "Updating Assigned User",
    "Assigned User Updated",
    null
  )
);
$("#status").on(
  "select2:select",
  changeSelectionVal.bind(
    null,
    "status",
    appId,
    false,
    appStatus,
    appStatusEdit,
    "statusUT",
    "Status",
    "Updating Status",
    "Status Updation Done",
    null
  )
);

// ok now handling the file thing
tenthMarksheet.addEventListener("dblclick", async function (e) {
  toggleHide(tenthMarksheet, tenthContainer);
});

twelvethMarksheet.addEventListener("dblclick", async function (e) {
  toggleHide(twelvethMarksheet, twelvethContainer);
});

diploma.addEventListener("dblclick", async function (e) {
  toggleHide(diploma, diplomaContainer);
});

bachelor.addEventListener("dblclick", async function (e) {
  toggleHide(bachelor, bachelorContainer);
});

master.addEventListener("dblclick", async function (e) {
  toggleHide(master, masterContainer);
});

lor.addEventListener("dblclick", async function (e) {
  toggleHide(lor, lorContainer);
});

sop.addEventListener("dblclick", async function (e) {
  toggleHide(sop, sopContainer);
});

resume.addEventListener("dblclick", async function (e) {
  toggleHide(resume, resumeContainer);
});

laexam.addEventListener("dblclick", async function (e) {
  toggleHide(laexam, laexamContainer);
});

// now for handling the file input

tenthInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Tenth_Marksheet",
    appId,
    true,
    tenthMarksheet,
    tenthContainer,
    "tenthUT",
    "10th Marksheet",
    "Uploading Document",
    "Document Uploaded",
    progressbartenth
  )
);
twelvethInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Twelveth_Marksheet",
    appId,
    true,
    twelvethMarksheet,
    twelvethContainer,
    "twelthhUT",
    "12th Marksheet",
    "Uploading Document",
    "Document Uploaded",
    progressbartwelth
  )
);
diplomaInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Diploma_Marksheet",
    appId,
    true,
    diploma,
    diplomaContainer,
    "diplomaUT",
    "Diploma Marksheet",
    "Uploading Document",
    "Document Uploaded",
    progressbardiploma
  )
);
bachelorInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Bachelor_Marksheet",
    appId,
    true,
    bachelor,
    bachelorContainer,
    "bachelorUT",
    "Bachelor Marksheet",
    "Uploading Document",
    "Document Uploaded",
    progressbarbachlor
  )
);
masterInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Master_Marksheet",
    appId,
    true,
    master,
    masterContainer,
    "masterUT",
    "Master Marksheet",
    "Uploading Document",
    "Document Uploaded",
    progressbarmaster
  )
);
lorInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Lor",
    appId,
    true,
    lor,
    lorContainer,
    "lorUT",
    "LOR",
    "Uploading Document",
    "Document Uploaded",
    progressbarlor
  )
);
sopInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Sop",
    appId,
    true,
    sop,
    sopContainer,
    "sopUT",
    "SOP",
    "Uploading Document",
    "Document Uploaded",
    progressbarsop
  )
);
resumeInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Resume",
    appId,
    true,
    resume,
    resumeContainer,
    "resumeUT",
    "Resume",
    "Uploading Document",
    "Document Uploaded",
    progressbarresume
  )
);
laexamInput.addEventListener(
  "change",
  changeSelectionVal.bind(
    null,
    "Language_Exam",
    appId,
    true,
    laexam,
    laexamContainer,
    "laUT",
    "Language Exam",
    "Uploading Document",
    "Document Uploaded",
    progressbarla
  )
);
